diff -ur sendmail-8.13.8-orig/sendmail/conf.c sendmail-8.13.8-dnsmap-samename/sendmail/conf.c
--- sendmail-8.13.8-orig/sendmail/conf.c	2006-03-22 17:49:33.000000000 -0500
+++ sendmail-8.13.8-dnsmap-samename/sendmail/conf.c	2006-11-02 23:47:04.000000000 -0500
@@ -6128,6 +6128,10 @@
 	/* Limit number of return values for DNS map. */
 	"_FFR_DNSMAP_MULTILIMIT",
 # endif /* _FFR_DNSMAP_MULTILIMIT */
+# if _FFR_DNSMAP_MULTI_SAMENAME
+	/* restrict matches to the ones with the same domain name */
+	"_FFR_DNSMAP_SAMENAME",
+# endif /* _FFR_DNSMAP_MULTI_SAMENAME */
 #endif /* _FFR_DNSMAP_MULTI */
 #if _FFR_DONTLOCKFILESFORREAD_OPTION
 	/* Enable DontLockFilesForRead option. */
diff -ur sendmail-8.13.8-orig/sendmail/map.c sendmail-8.13.8-dnsmap-samename/sendmail/map.c
--- sendmail-8.13.8-orig/sendmail/map.c	2006-04-17 21:26:41.000000000 -0400
+++ sendmail-8.13.8-dnsmap-samename/sendmail/map.c	2006-11-02 23:48:44.000000000 -0500
@@ -1137,6 +1137,9 @@
 #   if _FFR_DNSMAP_MULTILIMIT
 	int resnum = 0;
 #   endif /* _FFR_DNSMAP_MULTILIMIT */
+#   if _FFR_DNSMAP_MULTI_SAMENAME
+	char *vp_name = NULL;
+#   endif /* _FFR_DNSMAP_MULTI_SAMENAME */
 #  endif /* _FFR_DNSMAP_MULTI */
 	char *vp = NULL, *result = NULL;
 	size_t vsize;
@@ -1279,6 +1282,9 @@
 		{
 			/* First result */
 			vp = newstr(value);
+#   if _FFR_DNSMAP_MULTI_SAMENAME
+			vp_name = rr->rr_domain;
+#   endif /* _FFR_DNSMAP_MULTI_SAMENAME */
 		}
 		else
 		{
@@ -1286,6 +1292,11 @@
 			int sz;
 			char *new;
 
+#   if _FFR_DNSMAP_MULTI_SAMENAME
+			if(strcasecmp(vp_name, rr->rr_domain))
+				continue;
+#   endif /* _FFR_DNSMAP_MULTI_SAMENAME */
+
 			sz = strlen(vp) + strlen(value) + 2;
 			new = xalloc(sz);
 			(void) sm_snprintf(new, sz, "%s%c%s",
